(* POUR RECUPERER LES DONNEES DU FICHIER GENERE PAR FLEX *)

(* il faut rcuprer les tables yy_nxt, yy_accept et yy_NUL_trans *)

let trouve_yy_nxt in_channel = 
(*renvoie la taille des lignes la matrice yy_next  et se place juste aprs le ']'*)
  let c=ref 'a' and q=ref 0 and nb_t=ref 0 in
    try
      while(!q <> 6) do
	c:=input_char in_channel;
	(*print_int !q ;*)
	match (!q,!c) with
	  | (0,'y') -> q:=1;
	  | (1,'y') -> q:=2;
	  | (2,'_') -> q:=3;
	  | (2,'y') -> q:=2;	      
	  | (3,'n') -> q:=4;
	  | (4,'x') -> q:=5;
	  | (5,'t') -> q:=6;
	  | (_,'y') -> q:=1;
	  | (_,_) -> q:=0;
      done;
      for i=1 to 4 do c:=input_char in_channel done;
      while (!c<>']') do
	nb_t:=!nb_t*10+((int_of_char !c)-(int_of_char '0'));
	c:=input_char in_channel;
      done;
      !nb_t;
    with
	End_of_file -> failwith "file ended before finding yy_next";;



let trouve_yy_accept in_channel = 
(*renvoie le nombre d'lments du tableau yy_accept et se place juste aprs le ']'*)
  let c=ref 'a' and q=ref 0 and nb_t=ref 0 in
    try
      while(!q <> 9) do
	c:=input_char in_channel;
	(*print_int !q ;*)
	match (!q,!c) with
	  | (0,'y') -> q:=1;
	  | (1,'y') -> q:=2;
	  | (2,'_') -> q:=3;
	  | (2,'y') -> q:=2;	      
	  | (3,'a') -> q:=4;
	  | (4,'c') -> q:=5;
	  | (5,'c') -> q:=6;
	  | (6,'e') -> q:=7;
 	  | (7,'p') -> q:=8;     
	  | (8,'t') -> q:=9;
	  | (_,'y') -> q:=1;
	  | (_,_) -> q:=0;
      done;
      for i=1 to 2 do c:=input_char in_channel done;
      while (!c<>']') do
	nb_t:=!nb_t*10+((int_of_char !c)-(int_of_char '0'));
	c:=input_char in_channel;
      done;
      !nb_t;
    with
	End_of_file -> failwith "file ended before finding yy_accept";;




let trouve_yy_NUL_trans in_channel = 
(*renvoie le nombre d'lments du tableau yy_nul_trans et se place juste aprs le ']'*)
  let c=ref 'a' and q=ref 0 and nb_t=ref 0 in
    try
      while(!q <> 12) do
	c:=input_char in_channel;
	(*print_int !q ;*)
	match (!q,!c) with
	  | (0,'y') -> q:=1;
	  | (1,'y') -> q:=2;
	  | (2,'_') -> q:=3;
	  | (2,'y') -> q:=2;	      
	  | (3,'N') -> q:=4;
	  | (4,'U') -> q:=5;
	  | (5,'L') -> q:=6;
	  | (6,'_') -> q:=7;
 	  | (7,'t') -> q:=8;
 	  | (8,'r') -> q:=9;
 	  | (9,'a') -> q:=10;
   	  | (10,'n') -> q:=11;   
	  | (11,'s') -> q:=12;
	  | (_,'y') -> q:=1;
	  | (_,_) -> q:=0;
      done;
      for i=1 to 2 do c:=input_char in_channel done;
      while (!c<>']') do
	nb_t:=!nb_t*10+((int_of_char !c)-(int_of_char '0'));
	c:=input_char in_channel;
      done;
      !nb_t;
    with
	End_of_file -> failwith "file ended before finding yy_NUL_trans";;


let recupere_etat in_channel = 
(*avance, rcupre un chiffre et mange la virgule suivante ou le blanc suivant*)
  let c= ref ' ' and etat = ref 0 and negatif=ref false in
    while (!c=' ')  ||  (!c='\n') do
      c:=input_char in_channel;
    done;
    if (!c='-') then
      begin
	negatif:= true;
	c:=input_char in_channel
      end;
    (*else etat:=(int_of_char !c)-(int_of_char '0')*)
    while (!c<>',' && !c<>' '&& !c<>'\n') do
      etat:= (!etat * 10) + ((int_of_char !c)-(int_of_char '0'));
      c:=input_char in_channel
    done;
    if !negatif then (- !etat) else !etat;;

exception Fin_De_Matrice;;

let recupere_ligne nb_el in_channel = 
(*construit un tableau contenant une ligne entire *)
  let c=ref ' ' and res = Array.make nb_el 0 and nb = ref 0 in
    while (!c<>'{') do
      c:=input_char in_channel;
      if !c='}' then raise Fin_De_Matrice
    done;
    for i=1 to nb_el do
      res.(i-1)<-recupere_etat in_channel;
    done;
    while (!c<>'}') do c:=input_char in_channel done;
    res;;

let recupere_matrice nb_el in_channel=
 let l=ref [] and c=ref ' ' in
    try
      while (!c<>'{') do c:=input_char in_channel done;
      while true do 
	l:= (recupere_ligne nb_el in_channel)::(!l) done;
      Array.make 0 (Array.make 0 0) (* Hack ! *)
    with
	Fin_De_Matrice -> Array.of_list (List.rev !l);;

let get_yy_nxt fichier = 
(*ouvre le fichier, renvoie les 3 tables intressantes*)
  let in_channel = open_in fichier 
  and nb =ref 0 in
    nb := trouve_yy_nxt in_channel;
    let t1=recupere_matrice !nb in_channel in
      nb := trouve_yy_accept in_channel;
    let t2=recupere_ligne !nb in_channel in
      nb := trouve_yy_NUL_trans in_channel;
    let t3=recupere_ligne !nb in_channel in
      close_in in_channel;
    t1;;




